﻿using System;
using Microsoft.EntityFrameworkCore;

namespace TestTransactions
{

    public class SampleDbContext : DbContext
    {
        public const bool IsMySql = true;
        public const string schemaName = IsMySql ? "XXXXX" : "XXXXX";
        public const string ConnectionStringMySql = $"Data Source=localhost;database=XXXXX;userid=XXXXX;password=XXXXX;GuidFormat=none;UseXATransactions=true;AutoEnlist=true";
        public const string ConnectionStringSqlServer = $"Data Source=localhost;Initial Catalog=XXXXX;Encrypt=False;User Id=XXXXX;Password=XXXXX";

        public virtual DbSet<Sample> Samples { get; set; }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (IsMySql)
            {
                optionsBuilder.UseMySql(ConnectionStringMySql, ServerVersion.AutoDetect(ConnectionStringMySql));
            }
            else
            {
                optionsBuilder.UseSqlServer(ConnectionStringSqlServer);
            }
        }

        protected override void OnModelCreating(ModelBuilder builder)
        {
            var entity = builder.Entity<Sample>().ToTable("Sample", schemaName);
            entity.HasKey(x => x.SampleID);
        }

    }

}
